## ecere-sdk 0.44.01

=== Makefile ===
.PHONY: all clean realclean distclean emptyoutput prepinstall actualinstall install copyonlyinstall uninstall troubleshoot outputdirs bootstrap deps ecere ecerecom ecerevanilla ear compiler prepbinaries epj2make ide documentor eda prepcodeguard codeguard
.SILENT:

include include.mk

LIBVER := .0.44

ifdef WINDOWS

SOV := $(SO)

ifndef DESTDIR

ifdef ProgramFiles(x86)
export DESTDIR=${ProgramFiles(x86)}/Ecere SDK
else
ifdef ProgramFiles
export DESTDIR=$(ProgramFiles)/Ecere SDK
else
export DESTDIR=$(SystemDrive)/Ecere SDK
endif
endif

endif # DESTDIR

export prefix=

ifndef DOCDIR
export DOCDIR=$(DESTDIR)$(prefix)/doc
endif

ifndef BINDIR
export BINDIR=$(DESTDIR)$(prefix)/bin
endif

ifndef LIBDIR
export LIBDIR=$(BINDIR)
endif

ifndef SLIBDIR
export SLIBDIR=$(DESTDIR)$(prefix)/lib
endif

ifndef SAMPLESDIR
export SAMPLESDIR=$(DESTDIR)$(prefix)/samples
endif

ifndef EXTRASDIR
export EXTRASDIR=$(DESTDIR)$(prefix)/extras
endif


else # WINDOWS

SOV := $(SO)$(LIBVER)

ifndef DESTDIR
export DESTDIR=
endif

ifndef prefix
export prefix=/usr
endif

ifndef DOCDIR
export DOCDIR=$(DESTDIR)$(prefix)/share/ecere/doc
endif

ifndef MANDIR
export MANDIR=$(DESTDIR)$(prefix)/share/man/
endif

ifndef BINDIR
export BINDIR=$(DESTDIR)$(prefix)/bin
endif

HOSTTYPE := $(shell uname -m)

ifndef LIBDIR
ifeq "$(HOSTTYPE)" "x86_64"
export LIBDIR=$(DESTDIR)$(prefix)/lib32
export PREFIXLIBDIR=$(prefix)/lib32
else
export LIBDIR=$(DESTDIR)$(prefix)/lib
export PREFIXLIBDIR=$(prefix)/lib
endif
endif

ifndef SLIBDIR
ifeq "$(HOSTTYPE)" "x86_64"
export SLIBDIR=$(DESTDIR)$(prefix)/lib32
else
export SLIBDIR=$(DESTDIR)$(prefix)/lib
endif
endif

ifndef SAMPLESDIR
export SAMPLESDIR=$(DESTDIR)$(prefix)/share/ecere/samples
endif

ifndef EXTRASDIR
export EXTRASDIR=$(DESTDIR)$(prefix)/share/ecere/extras
endif


endif

OBJDIR := obj$(OBJALT)/
OBJBINDIR := $(OBJDIR)$(PLATFORM)/bin/
OBJLIBDIR := $(OBJDIR)$(PLATFORM)/lib/

all: prepbinaries ide epj2make documentor eda codeguard
	@$(call echo,The Ecere SDK is fully built.)

outputdirs:
	$(if $(wildcard $(OBJDIR)),,$(call mkdirq,$(OBJDIR)))
	$(if $(wildcard $(OBJBINDIR)),,$(call mkdirq,$(OBJBINDIR)))
	$(if $(wildcard $(OBJLIBDIR)),,$(call mkdirq,$(OBJLIBDIR)))

bootstrap: outputdirs
	cd compiler && $(MAKE) bootstrap

deps:
	@$(call echo,Building dependencies...)
	cd deps && $(MAKE)

ecere: bootstrap deps
	@$(call echo,Building 2nd stage ecere...)
	cd ecere && $(MAKE) nores
	cd ear && $(MAKE) nores
	cd ecere && $(MAKE) cleantarget
	cd ecere && $(MAKE)

ecerecom: bootstrap
	@$(call echo,Building eC Core Runtime...)
	cd ecere && $(MAKE) -f Makefile.ecereCOM

ecerevanilla: bootstrap
	@$(call echo,Building Vanilla Ecere...)
	cd ecere && $(MAKE) -f Makefile.vanilla

ear: ecere ecerevanilla
	@$(call echo,Building ear...)
	cd ear && cd cmd && $(MAKE) cleantarget
	cd ear && $(MAKE)

compiler: ecere ear
	@$(call echo,Building 2nd stage compiler)
	cd compiler && $(MAKE)

prepbinaries: compiler ecerecom
	@$(call echo,Enabling 2nd stage binaries...)
ifdef WINDOWS
	$(call cpq,ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SOV),$(OBJBINDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SOV),$(OBJBINDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SOV),$(OBJBINDIR))
endif
ifdef LINUX
	$(call cpq,ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SOV),$(OBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SOV),$(OBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SOV),$(OBJLIBDIR))
	ln -sf $(LP)ecere$(SOV) $(OBJLIBDIR)$(LP)ecere$(SO).0
	ln -sf $(LP)ecereCOM$(SOV) $(OBJLIBDIR)$(LP)ecereCOM$(SO).0
	ln -sf $(LP)ec$(SOV) $(OBJLIBDIR)$(LP)ec$(SO).0
	ln -sf $(LP)ecere$(SOV) $(OBJLIBDIR)$(LP)ecere$(SO)
	ln -sf $(LP)ecereCOM$(SOV) $(OBJLIBDIR)$(LP)ecereCOM$(SO)
	ln -sf $(LP)ec$(SOV) $(OBJLIBDIR)$(LP)ec$(SO)
endif
ifndef WINDOWS
ifndef LINUX
	$(call cpq,ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SO),$(OBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SO),$(OBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SO),$(OBJLIBDIR))
endif
endif
	$(call cpq,ear/cmd/obj/release.$(PLATFORM)/ear$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecc/obj/release.$(PLATFORM)/ecc$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecp/obj/release.$(PLATFORM)/ecp$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecs/obj/release.$(PLATFORM)/ecs$(E),$(OBJBINDIR))

epj2make: prepbinaries
	@$(call echo,Building epj2make...)
	cd epj2make && $(MAKE)

ide: prepbinaries
	@$(call echo,Building IDE...)
	cd ide && $(MAKE)

documentor: prepbinaries
	@$(call echo,Building Documentor...)
	cd documentor && $(MAKE)

codeguard: prepcodeguard
ifdef CodeGuard
	@$(call echo,Building CodeGuard client...)
	cd codeGuard && $(MAKE)
endif

prepcodeguard: eda
ifdef CodeGuard
ifdef WINDOWS
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SO),$(OBJBINDIR))
endif

ifdef LINUX
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SOV),$(OBJLIBDIR))
	ln -sf $(LP)EDA$(SOV) $(OBJLIBDIR)$(LP)EDA$(SO).0
	ln -sf $(LP)EDA$(SOV) $(OBJLIBDIR)$(LP)EDA$(SO)
endif

ifndef WINDOWS
ifndef LINUX
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SO),$(OBJLIBDIR))
endif
endif
endif

eda: prepbinaries
	@$(call echo,Building EDA...)
	cd eda && $(MAKE)

emptyoutput: outputdirs
	$(call rmq,$(OBJLIBDIR)libecereVanilla$(A))
	$(call rmq,$(SODESTDIR)$(LP)ecere$(SO))
	$(call rmq,$(SODESTDIR)$(LP)ecereCOM$(SO))
	$(call rmq,$(SODESTDIR)$(LP)ec$(SO))
	$(call rmq,$(SODESTDIR)$(LP)EDA$(SO))
	$(call rmq,$(SODESTDIR)$(LP)EDASQLite$(SO))
ifdef EDASQLiteCipher
	$(call rmq,$(SODESTDIR)$(LP)EDASQLiteCipher$(SO))
endif
ifdef LINUX
	$(call rmq,$(SODESTDIR)$(LP)ecere$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)ecereCOM$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)ec$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)EDA$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)EDASQLite$(SO).0)
ifdef EDASQLiteCipher
	$(call rmq,$(SODESTDIR)$(LP)EDASQLiteCipher$(SO).0)
endif
	$(call rmq,$(SODESTDIR)$(LP)ecere$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)ecereCOM$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)ec$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)EDA$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)EDASQLite$(SOV))
ifdef EDASQLiteCipher
	$(call rmq,$(SODESTDIR)$(LP)EDASQLiteCipher$(SOV))
endif
endif	
	$(call rmq,$(OBJBINDIR)ear$(E))
	$(call rmq,$(OBJBINDIR)ecc$(E))
	$(call rmq,$(OBJBINDIR)ecp$(E))
	$(call rmq,$(OBJBINDIR)ecs$(E))
	$(call rmq,$(OBJBINDIR)epj2make$(E))
	$(call rmq,$(OBJBINDIR)ide$(E))
	$(call rmq,$(OBJBINDIR)documentor$(E))
ifdef EDASQLiteCipher
	$(call rmq,$(OBJBINDIR)CodeGuard$(E))
endif

clean: emptyoutput
	cd deps && $(MAKE) clean
	cd ecere && $(MAKE) clean
	cd compiler && $(MAKE) clean
	cd ear && $(MAKE) clean
	cd epj2make && $(MAKE) clean
	cd ide && $(MAKE) clean
	cd documentor && $(MAKE) clean
ifdef CodeGuard
	cd codeGuard && $(MAKE) clean
endif
	cd eda && $(MAKE) clean
	@$(call echo,Done.)

realclean:
	cd deps && $(MAKE) realclean
	cd ecere && $(MAKE) realclean
	cd compiler && $(MAKE) realclean
	cd ear && $(MAKE) realclean
	cd epj2make && $(MAKE) realclean
	cd ide && $(MAKE) realclean
	cd documentor && $(MAKE) realclean
ifdef CodeGuard
	cd codeGuard && $(MAKE) realclean
endif
	cd eda && $(MAKE) realclean
	$(call rmrq,obj/$(PLATFORM)/)
	@$(call echo,Done.)

distclean:
	cd deps && $(MAKE) distclean
	cd ecere && $(MAKE) distclean
	cd compiler && $(MAKE) distclean
	cd ear && $(MAKE) distclean
	cd epj2make && $(MAKE) distclean
	cd ide && $(MAKE) distclean
	cd documentor && $(MAKE) distclean
ifdef CodeGuard
	cd codeGuard && $(MAKE) distclean
endif
	cd eda && $(MAKE) distclean
	$(call rmrq,obj/)
	@$(call echo,Done.)

DOC = doc/ecere.eCdoc doc/ecereCOM.eCdoc doc/EDA.eCdoc

BINARIES = \
	ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SOV) \
	ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SOV) \
	ecere/obj/vanilla.$(PLATFORM)/libecereVanilla$(A) \
	compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SOV) \
	compiler/ecp/obj/release.$(PLATFORM)/ecp$(E) \
	compiler/ecc/obj/release.$(PLATFORM)/ecc$(E) \
	compiler/ecs/obj/release.$(PLATFORM)/ecs$(E) \
	ear/cmd/obj/release.$(PLATFORM)/ear$(E) \
	epj2make/obj/release.$(PLATFORM)/epj2make$(E) \
	documentor/obj/release.$(PLATFORM)/documentor$(E) \
	ide/obj/release.$(PLATFORM)/ide$(E) \
	eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SOV) \
	eda/drivers/sqlite/obj/release.$(PLATFORM)/$(LP)EDASQLite$(SOV)

ifdef CodeGuard
BINARIES += codeGuard/obj/release.$(PLATFORM)/CodeGuard$(E)
endif

ifdef EDASQLiteCipher
BINARIES += eda/drivers/sqliteCipher/obj/release.$(PLATFORM)/$(LP)EDASQLiteCipher$(SOV)
endif

# Making sure everything is in $(OBJBINDIR) and $(OBJLIBDIR)
# Shared Libraries (in $(OBJBINDIR) on Windows and $(OBJLIBDIR) otherwise)
# Symlinks for libs on Linux
# Binaries (always in $(OBJBINDIR)) and Static Libraries (always in $(OBJLIBDIR))
prepinstall: $(DOC) $(BINARIES) outputdirs

ifdef WINDOWS
	$(call cpq,ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SO),$(OBJBINDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SO),$(OBJBINDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SO),$(OBJBINDIR))
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SO),$(OBJBINDIR))
	$(call cpq,eda/drivers/sqlite/obj/release.$(PLATFORM)/$(LP)EDASQLite$(SO),$(OBJBINDIR))
ifdef EDASQLiteCipher
	$(call cpq,eda/drivers/sqliteCipher/obj/release.$(PLATFORM)/$(LP)EDASQLiteCipher$(SO),$(OBJBINDIR))
endif
endif

ifdef LINUX
	$(call cpq,ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SOV),$(OBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SOV),$(OBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SOV),$(OBJLIBDIR))
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SOV),$(OBJLIBDIR))
	$(call cpq,eda/drivers/sqlite/obj/release.$(PLATFORM)/$(LP)EDASQLite$(SOV),$(OBJLIBDIR))
ifdef EDASQLiteCipher
	$(call cpq,eda/drivers/sqliteCipher/obj/release.$(PLATFORM)/$(LP)EDASQLiteCipher$(SOV),$(OBJLIBDIR))
endif
	ln -sf $(LP)ecere$(SOV) $(OBJLIBDIR)$(LP)ecere$(SO).0
	ln -sf $(LP)ecereCOM$(SOV) $(OBJLIBDIR)$(LP)ecereCOM$(SO).0
	ln -sf $(LP)ec$(SOV) $(OBJLIBDIR)$(LP)ec$(SO).0
	ln -sf $(LP)EDA$(SOV) $(OBJLIBDIR)$(LP)EDA$(SO).0
	ln -sf $(LP)EDASQLite$(SOV) $(OBJLIBDIR)$(LP)EDASQLite$(SO).0
ifdef EDASQLiteCipher
	ln -sf $(LP)EDASQLiteCipher$(SOV) $(OBJLIBDIR)$(LP)EDASQLiteCipher$(SO).0
endif
	ln -sf $(LP)ecere$(SOV) $(OBJLIBDIR)$(LP)ecere$(SO)
	ln -sf $(LP)ecereCOM$(SOV) $(OBJLIBDIR)$(LP)ecereCOM$(SO)
	ln -sf $(LP)ec$(SOV) $(OBJLIBDIR)$(LP)ec$(SO)
	ln -sf $(LP)EDA$(SOV) $(OBJLIBDIR)$(LP)EDA$(SO)
	ln -sf $(LP)EDASQLite$(SOV) $(OBJLIBDIR)$(LP)EDASQLite$(SO)
ifdef EDASQLiteCipher
	ln -sf $(LP)EDASQLiteCipher$(SOV) $(OBJLIBDIR)$(LP)EDASQLiteCipher$(SO)
endif
endif

ifndef WINDOWS
ifndef LINUX
	$(call cpq,ecere/obj/release.$(PLATFORM)/$(LP)ecere$(SO),$(OBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)/$(LP)ecereCOM$(SO),$(OBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)/$(LP)ec$(SO),$(OBJLIBDIR))
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SO),$(OBJLIBDIR))
	$(call cpq,eda/drivers/sqlite/obj/release.$(PLATFORM)/$(LP)EDASQLite$(SO),$(OBJLIBDIR))
ifdef EDASQLiteCipher
	$(call cpq,eda/drivers/sqliteCipher/obj/release.$(PLATFORM)/$(LP)EDASQLiteCipher$(SO),$(OBJLIBDIR))
endif
endif
endif

	$(call cpq,ide/obj/release.$(PLATFORM)/ide$(E),$(OBJBINDIR))
	$(call cpq,ear/cmd/obj/release.$(PLATFORM)/ear$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecc/obj/release.$(PLATFORM)/ecc$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecp/obj/release.$(PLATFORM)/ecp$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecs/obj/release.$(PLATFORM)/ecs$(E),$(OBJBINDIR))
	$(call cpq,epj2make/obj/release.$(PLATFORM)/epj2make$(E),$(OBJBINDIR))
	$(call cpq,documentor/obj/release.$(PLATFORM)/documentor$(E),$(OBJBINDIR))
ifdef CodeGuard
	$(call cpq,codeGuard/obj/release.$(PLATFORM)/CodeGuard$(E),$(OBJBINDIR))
endif
	$(call cpq,ecere/obj/vanilla.$(PLATFORM)/libecereVanilla$(A),$(OBJLIBDIR))

#TODO: Samples?
install: prepinstall actualinstall
	@$(call echo,The Ecere SDK has been installed.)

=== compiler/Makefile ===
.PHONY: all bootstrap clean realclean distclean libec ecp ecc ecs
.SILENT:

CONFIG := release
OBJ = libec/obj/$(CONFIG).$(PLATFORM)/
PRECOMPILED_SOURCES = libec/precompiled/expression.c libec/precompiled/grammar.c libec/precompiled/type.c

include ../include.mk

all: ecp ecc ecs

libec:
	@$(call echo,Building 2nd stage libec...)
ifeq "$(wildcard libec/precompiled)" "libec/precompiled"
ifneq "$(wildcard $(OBJ))" "$(OBJ)"
	$(call mkdirq,$(OBJ))
endif
	$(call cpq,$(PRECOMPILED_SOURCES),$(OBJ))
endif
	cd libec && $(MAKE)

ecp: libec
	@$(call echo,Building 2nd stage ecp...)
	cd ecp && $(MAKE)

ecc: libec
	@$(call echo,Building 2nd stage ecc...)
	cd ecc && $(MAKE)

ecs: libec
	@$(call echo,Building 2nd stage ecs...)
	cd ecs && $(MAKE)

bootstrap:
	@$(call echo,Bootstrapping eC compiling tools...)
	cd bootstrap && $(MAKE)

clean:
	cd bootstrap && $(MAKE) clean
	cd libec && $(MAKE) clean
	cd ecp && $(MAKE) clean
	cd ecc && $(MAKE) clean
	cd ecs && $(MAKE) clean

realclean:
	cd bootstrap && $(MAKE) realclean
	cd libec && $(MAKE) realclean
	cd ecp && $(MAKE) realclean
	cd ecc && $(MAKE) realclean
	cd ecs && $(MAKE) realclean

distclean:
	cd bootstrap && $(MAKE) distclean
	cd libec && $(MAKE) distclean
	cd ecp && $(MAKE) distclean
	cd ecc && $(MAKE) distclean
	cd ecs && $(MAKE) distclean

=== deps/Makefile ===
.PHONY: freetype jpeg png gif z ffi clean realclean distclean
.SILENT:

# CROSS-PLATFORM MAGIC

include ../include.mk

ifdef WINDOWS
all: freetype jpeg png gif ffi z
else
ifdef OSX
all: jpeg png gif
else
all: gif
endif
endif

clean:
	cd freetype-2.3.12 && $(MAKE) clean
	cd libpng-1.4.0 && $(MAKE) clean
	cd zlib && $(MAKE) clean
	cd jpeg-6b && $(MAKE) clean
	cd libungif-4.1.1 && $(MAKE) clean
	cd libffi-3.0.11 && $(MAKE) clean

realclean:
	cd freetype-2.3.12 && $(MAKE) realclean
	cd libpng-1.4.0 && $(MAKE) realclean
	cd zlib && $(MAKE) realclean
	cd jpeg-6b && $(MAKE) realclean
	cd libungif-4.1.1 && $(MAKE) realclean
	cd libffi-3.0.11 && $(MAKE) realclean

distclean:
	cd freetype-2.3.12 && $(MAKE) distclean
	cd libpng-1.4.0 && $(MAKE) distclean
	cd zlib && $(MAKE) distclean
	cd jpeg-6b && $(MAKE) distclean
	cd libungif-4.1.1 && $(MAKE) distclean
	cd libffi-3.0.11 && $(MAKE) distclean

freetype:
	@$(call echo,Building FreeType...)
	cd freetype-2.3.12 && $(MAKE)
	
jpeg:
	@$(call echo,Building libjpeg...)
	cd jpeg-6b && $(MAKE)

png:
	@$(call echo,Building libpng...)
	cd libpng-1.4.0 && $(MAKE)

gif:
	@$(call echo,Building libungif...)
	cd libungif-4.1.1 && $(MAKE)

z:
	@$(call echo,Building zlib...)
	cd zlib && $(MAKE)

ffi:
	@$(call echo,Building libffi...)
	cd libffi-3.0.11 && $(MAKE)

=== documentor/Makefile ===
.PHONY: all objdir clean realclean distclean

# CONTENT

MODULE := documentor
CONFIG := release
COMPILER := default
TARGET_TYPE = executable

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = 

CONSOLE = -mwindows

TARGET = obj/$(CONFIG).$(PLATFORM)/documentor$(E)

OBJECTS = \
	$(OBJ)htmlParser.o \
	$(OBJ)HTMLView.o \
	$(OBJ)lines.o \
	$(OBJ)tables.o \
	$(OBJ)IDESettings.o \
	$(OBJ)OldIDESettings.o \
	$(OBJ)StringsBox.o \
	$(OBJ)Documentor.o \
	$(OBJ)SettingsDialog.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = \
	$(OBJ)htmlParser.c \
	$(OBJ)HTMLView.c \
	$(OBJ)lines.c \
	$(OBJ)tables.c \
	$(OBJ)IDESettings.c \
	$(OBJ)OldIDESettings.c \
	$(OBJ)StringsBox.c \
	$(OBJ)Documentor.c \
	$(OBJ)SettingsDialog.c

SYMBOLS = \
	$(OBJ)htmlParser.sym \
	$(OBJ)HTMLView.sym \
	$(OBJ)lines.sym \
	$(OBJ)tables.sym \
	$(OBJ)IDESettings.sym \
	$(OBJ)OldIDESettings.sym \
	$(OBJ)StringsBox.sym \
	$(OBJ)Documentor.sym \
	$(OBJ)SettingsDialog.sym

IMPORTS = \
	$(OBJ)htmlParser.imp \
	$(OBJ)HTMLView.imp \
	$(OBJ)lines.imp \
	$(OBJ)tables.imp \
	$(OBJ)IDESettings.imp \
	$(OBJ)OldIDESettings.imp \
	$(OBJ)StringsBox.imp \
	$(OBJ)Documentor.imp \
	$(OBJ)SettingsDialog.imp

SOURCES = \
	../extras/html/htmlParser.ec \
	../extras/html/HTMLView.ec \
	../extras/html/lines.ec \
	../extras/html/tables.ec \
	../ide/src/IDESettings.ec \
	../ide/src/OldIDESettings.ec \
	../extras/gui/controls/StringsBox.ec \
	src/Documentor.ec \
	src/SettingsDialog.ec

RESOURCES = \
	locale/zh_CN/LC_MESSAGES/documentor.mo \
	locale/es_ES/LC_MESSAGES/documentor.mo \
	res/documentorIcon.png

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../include.mk

# TOOLCHAIN
export LD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
export DYLD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
ECP := $(call psep,../obj/$(PLATFORM)/bin/ecp)
ECC := $(call psep,../obj/$(PLATFORM)/bin/ecc)
ECS := $(call psep,../obj/$(PLATFORM)/bin/ecs)
EAR := $(call psep,../obj/$(PLATFORM)/bin/ear)

# FLAGS

CFLAGS += -fmessage-length=0 -O2 -ffast-math -m32 $(FPIC) -w

CECFLAGS =

ECFLAGS = -nolinenumbers

OFLAGS += -m32 \
	 -L../obj/$(PLATFORM)/bin \
	 -L../obj/$(PLATFORM)/lib

LIBS = -lecere $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

UPXFLAGS = -9 -q

# HARD CODED PLATFORM-SPECIFIC OPTIONS
ifdef LINUX
OFLAGS += -Wl,--no-undefined
endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
	$(EAR) awq $(TARGET) res/documentorIcon.png ""
	$(EAR) awq $(TARGET) locale/zh_CN/LC_MESSAGES/documentor.mo "locale/zh_CN/LC_MESSAGES"
	$(EAR) awq $(TARGET) locale/es_ES/LC_MESSAGES/documentor.mo "locale/es_ES/LC_MESSAGES"
	$(call cpq,$(TARGET),../obj/$(PLATFORM)/bin/)

# SYMBOL RULES

$(OBJ)htmlParser.sym: ../extras/html/htmlParser.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../extras/html/htmlParser.ec -o $(OBJ)htmlParser.sym

$(OBJ)HTMLView.sym: ../extras/html/HTMLView.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../extras/html/HTMLView.ec -o $(OBJ)HTMLView.sym

$(OBJ)lines.sym: ../extras/html/lines.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../extras/html/lines.ec -o $(OBJ)lines.sym

$(OBJ)tables.sym: ../extras/html/tables.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../extras/html/tables.ec -o $(OBJ)tables.sym

$(OBJ)IDESettings.sym: ../ide/src/IDESettings.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/IDESettings.ec -o $(OBJ)IDESettings.sym

$(OBJ)OldIDESettings.sym: ../ide/src/OldIDESettings.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/OldIDESettings.ec -o $(OBJ)OldIDESettings.sym

$(OBJ)StringsBox.sym: ../extras/gui/controls/StringsBox.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../extras/gui/controls/StringsBox.ec -o $(OBJ)StringsBox.sym

$(OBJ)Documentor.sym: src/Documentor.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c src/Documentor.ec -o $(OBJ)Documentor.sym

$(OBJ)SettingsDialog.sym: src/SettingsDialog.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c src/SettingsDialog.ec -o $(OBJ)SettingsDialog.sym

# C OBJECT RULES

$(OBJ)htmlParser.c: ../extras/html/htmlParser.ec $(OBJ)htmlParser.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../extras/html/htmlParser.ec -o $(OBJ)htmlParser.c -symbols $(OBJ)

$(OBJ)HTMLView.c: ../extras/html/HTMLView.ec $(OBJ)HTMLView.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../extras/html/HTMLView.ec -o $(OBJ)HTMLView.c -symbols $(OBJ)

$(OBJ)lines.c: ../extras/html/lines.ec $(OBJ)lines.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../extras/html/lines.ec -o $(OBJ)lines.c -symbols $(OBJ)

$(OBJ)tables.c: ../extras/html/tables.ec $(OBJ)tables.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../extras/html/tables.ec -o $(OBJ)tables.c -symbols $(OBJ)

$(OBJ)IDESettings.c: ../ide/src/IDESettings.ec $(OBJ)IDESettings.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/IDESettings.ec -o $(OBJ)IDESettings.c -symbols $(OBJ)

$(OBJ)OldIDESettings.c: ../ide/src/OldIDESettings.ec $(OBJ)OldIDESettings.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/OldIDESettings.ec -o $(OBJ)OldIDESettings.c -symbols $(OBJ)

$(OBJ)StringsBox.c: ../extras/gui/controls/StringsBox.ec $(OBJ)StringsBox.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../extras/gui/controls/StringsBox.ec -o $(OBJ)StringsBox.c -symbols $(OBJ)

$(OBJ)Documentor.c: src/Documentor.ec $(OBJ)Documentor.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c src/Documentor.ec -o $(OBJ)Documentor.c -symbols $(OBJ)

$(OBJ)SettingsDialog.c: src/SettingsDialog.ec $(OBJ)SettingsDialog.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c src/SettingsDialog.ec -o $(OBJ)SettingsDialog.c -symbols $(OBJ)

# OBJECT RULES

$(OBJ)htmlParser.o: $(OBJ)htmlParser.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)htmlParser.c -o $(OBJ)htmlParser.o

$(OBJ)HTMLView.o: $(OBJ)HTMLView.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)HTMLView.c -o $(OBJ)HTMLView.o

$(OBJ)lines.o: $(OBJ)lines.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)lines.c -o $(OBJ)lines.o

$(OBJ)tables.o: $(OBJ)tables.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)tables.c -o $(OBJ)tables.o

$(OBJ)IDESettings.o: $(OBJ)IDESettings.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)IDESettings.c -o $(OBJ)IDESettings.o

$(OBJ)OldIDESettings.o: $(OBJ)OldIDESettings.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)OldIDESettings.c -o $(OBJ)OldIDESettings.o

$(OBJ)StringsBox.o: $(OBJ)StringsBox.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)StringsBox.c -o $(OBJ)StringsBox.o

$(OBJ)Documentor.o: $(OBJ)Documentor.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)Documentor.c -o $(OBJ)Documentor.o

$(OBJ)SettingsDialog.o: $(OBJ)SettingsDialog.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)SettingsDialog.c -o $(OBJ)SettingsDialog.o

$(OBJ)$(MODULE).main$(O): $(OBJ)$(MODULE).main.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.c -o $(OBJ)$(MODULE).main$(O)

clean: objdir
	$(call rmq,$(OBJ)$(MODULE).main.c $(OBJ)$(MODULE).main.ec $(OBJ)$(MODULE).main$(I) $(OBJ)$(MODULE).main$(S) $(TARGET))
	$(call rmq,$(OBJECTS))
	$(call rmq,$(COBJECTS))
	$(call rmq,$(IMPORTS))
	$(call rmq,$(SYMBOLS))

realclean:
	$(call rmrq,$(OBJ))

distclean:
	$(call rmrq,obj/)

=== ear/Makefile ===
.SILENT:
.PHONY: all nores clean realclean distclean

# CROSS-PLATFORM MAGIC

include ../include.mk

all:
	@$(call echo,Building self-extract tool...)
	cd extract && $(MAKE)
	@$(call echo,Building eAR command line tool...)
	cd cmd && $(MAKE)

nores:
	@$(call echo,Building eAR command line tool...)
	cd cmd && $(MAKE) nores

clean:
	cd extract && $(MAKE) clean
	cd cmd && $(MAKE) clean

realclean:
	cd extract && $(MAKE) realclean
	cd cmd && $(MAKE) realclean

distclean:
	cd extract && $(MAKE) distclean
	cd cmd && $(MAKE) distclean

=== ecere/Makefile ===
.PHONY: objdir clean cleantarget realclean distclean nores

# CONTENT

MODULE := ecere
CONFIG := release
COMPILER := default
TARGET_TYPE = sharedlib

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = res/

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../include.mk

ifdef LINUX
TARGET = obj/$(CONFIG).$(PLATFORM)/$(LP)$(MODULE)$(SO).0.44
SONAME = -Wl,-soname,libecere.so.0
else
TARGET = obj/$(CONFIG).$(PLATFORM)/$(LP)$(MODULE)$(SO)
SONAME =
endif

OBJECTS = $(OBJECTS1) $(OBJECTS2) $(OBJECTS3) $(OBJECTS4)
OBJECTS1 = \
	$(OBJ)Archive.o \
	$(OBJ)BufferedFile.o \
	$(OBJ)Date.o \
	$(OBJ)DualPipe.o \
	$(OBJ)EARArchive.o \
	$(OBJ)File.o \
	$(OBJ)FileMonitor.o \
	$(OBJ)GlobalAppSettings.o \
	$(OBJ)JSON.o \
	$(OBJ)JSONGlobalSettings.o \
	$(OBJ)memory.o \
	$(OBJ)Mutex.o \
	$(OBJ)Semaphore.o \
	$(OBJ)System.o \
	$(OBJ)TempFile.o \
	$(OBJ)Thread.o \
	$(OBJ)Time.o \
	$(OBJ)unicode.o \
	$(OBJ)units.o \
	$(OBJ)File.c.o \
	$(OBJ)DualPipe.c.o \
	$(OBJ)System.c.o \
	$(OBJ)i18n.o \
	$(OBJ)Cube.o \
	$(OBJ)SkyBox.o \
	$(OBJ)Sphere.o \
	$(OBJ)Object3DSFormat.o \
	$(OBJ)Camera.o \
	$(OBJ)Matrix.o \
	$(OBJ)Mesh.o \
	$(OBJ)Object.o \
	$(OBJ)Plane.o \
	$(OBJ)Quaternion.o \
	$(OBJ)Vector3D.o \
	$(OBJ)BMPFormat.o \
	$(OBJ)GIFFormat.o \
	$(OBJ)JPEGFormat.o \
	$(OBJ)PCXFormat.o \
	$(OBJ)PNGFormat.o \
	$(OBJ)RGBFormat.o \
	$(OBJ)harfbuzz-freetype.o \
	$(OBJ)harfbuzz-unicode-tables.o \
	$(OBJ)harfbuzz-unicode.o \
	$(OBJ)harfbuzz-arabic.o \
	$(OBJ)harfbuzz-buffer.o \
	$(OBJ)harfbuzz-gdef.o \
	$(OBJ)harfbuzz-gpos.o \
	$(OBJ)harfbuzz-gsub.o \
	$(OBJ)harfbuzz-hangul.o
OBJECTS2 = \
	$(OBJ)harfbuzz-hebrew.o \
	$(OBJ)harfbuzz-indic.o \
	$(OBJ)harfbuzz-khmer.o \
	$(OBJ)harfbuzz-myanmar.o \
	$(OBJ)harfbuzz-open.o \
	$(OBJ)harfbuzz-shaper.o \
	$(OBJ)harfbuzz-stream.o \
	$(OBJ)harfbuzz-tibetan.o \
	$(OBJ)harfbuzz-impl.o \
	$(OBJ)harfbuzz-thai.o \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.o,) \
	$(OBJ)lfbBlit.o \
	$(OBJ)lfbConvert.o \
	$(OBJ)LFBDisplayDriver.o \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesDisplayDriver.o,) \
	$(if $(OSX),,$(OBJ)OpenGLDisplayDriver.o) \
	$(if $(WINDOWS),$(OBJ)Win32BitmapPrinterDisplayDriver.o,) \
	$(if $(OSX),$(OBJ)CocoaOpenGLDisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleDisplayDriver.o,) \
	$(if $(WINDOWS),$(OBJ)Win32PrinterDisplayDriver.o,) \
	$(if $(LINUX),$(OBJ)XDisplayDriver.o,) \
	$(OBJ)Bitmap.o \
	$(OBJ)BitmapResource.o \
	$(OBJ)Color.o \
	$(OBJ)Display.o \
	$(OBJ)DisplaySystem.o \
	$(OBJ)FontResource.o \
	$(OBJ)Resource.o \
	$(OBJ)Surface.o \
	$(OBJ)Button.o \
	$(OBJ)CalendarControl.o \
	$(OBJ)DataBox.o
OBJECTS3 = \
	$(OBJ)DropBox.o \
	$(OBJ)EditBox.o \
	$(OBJ)Label.o \
	$(OBJ)ListBox.o \
	$(OBJ)Menu.o \
	$(OBJ)Picture.o \
	$(OBJ)ProgressBar.o \
	$(OBJ)ScrollBar.o \
	$(OBJ)StatusBar.o \
	$(OBJ)TabControl.o \
	$(OBJ)PaneSplitter.o \
	$(OBJ)Stacker.o \
	$(OBJ)PathBox.o \
	$(OBJ)ToolTip.o \
	$(OBJ)SelectorBar.o \
	$(OBJ)ColorPicker.o \
	$(OBJ)FileDialog.o \
	$(OBJ)FindDialog.o \
	$(OBJ)GoToDialog.o \
	$(OBJ)MessageBox.o \
	$(OBJ)ReplaceDialog.o \
	$(OBJ)WindowList.o \
	$(if $(OSX),$(OBJ)CocoaDispatch.o,) \
	$(if $(OSX),$(OBJ)CocoaEcereBridge.o,) \
	$(if $(OSX),$(OBJ)CocoaInterface.o,) \
	$(if $(OSX),$(OBJ)EcereView.o,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesInterface.o,) \
	$(if $(WINDOWS),$(OBJ)Win32Interface.o,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleInterface.o,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)XInterface.o,) \
	$(OBJ)TVisionSkin.o \
	$(OBJ)WindowsSkin.o \
	$(OBJ)Anchor.o \
	$(OBJ)ClipBoard.o \
	$(OBJ)Cursor.o \
	$(OBJ)Desktop3D.o \
	$(OBJ)FormDesigner.o \
	$(OBJ)GuiApplication.o \
	$(OBJ)Interface.o \
	$(OBJ)Key.o \
	$(OBJ)Skin.o \
	$(OBJ)Timer.o
OBJECTS4 = \
	$(OBJ)typeEdit.o \
	$(OBJ)Window.o \
	$(OBJ)dcom.o \
	$(OBJ)HTTPFile.o \
	$(OBJ)network.o \
	$(OBJ)NetworkClientFile.o \
	$(OBJ)Service.o \
	$(OBJ)Socket.o \
	$(OBJ)Array.o \
	$(OBJ)AVLTree.o \
	$(OBJ)BuiltInContainer.o \
	$(OBJ)Container.o \
	$(OBJ)CustomAVLTree.o \
	$(OBJ)LinkList.o \
	$(OBJ)List.o \
	$(OBJ)Map.o \
	$(OBJ)BinaryTree.o \
	$(OBJ)BTNode.o \
	$(OBJ)dataTypes.o \
	$(OBJ)instance.o \
	$(OBJ)String.o \
	$(OBJ)OldList.o \
	$(OBJ)instance.c.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = $(COBJECTS1) $(COBJECTS2) $(COBJECTS3)
COBJECTS1 = \
	$(OBJ)Archive.c \
	$(OBJ)BufferedFile.c \
	$(OBJ)Date.c \
	$(OBJ)DualPipe.c \
	$(OBJ)EARArchive.c \
	$(OBJ)File.c \
	$(OBJ)FileMonitor.c \
	$(OBJ)GlobalAppSettings.c \
	$(OBJ)JSON.c \
	$(OBJ)JSONGlobalSettings.c \
	$(OBJ)memory.c \
	$(OBJ)Mutex.c \
	$(OBJ)Semaphore.c \
	$(OBJ)System.c \
	$(OBJ)TempFile.c \
	$(OBJ)Thread.c \
	$(OBJ)Time.c \
	$(OBJ)unicode.c \
	$(OBJ)units.c \
	$(OBJ)i18n.c \
	$(OBJ)Cube.c \
	$(OBJ)SkyBox.c \
	$(OBJ)Sphere.c \
	$(OBJ)Object3DSFormat.c \
	$(OBJ)Camera.c \
	$(OBJ)Matrix.c \
	$(OBJ)Mesh.c \
	$(OBJ)Object.c \
	$(OBJ)Plane.c \
	$(OBJ)Quaternion.c \
	$(OBJ)Vector3D.c \
	$(OBJ)BMPFormat.c \
	$(OBJ)GIFFormat.c \
	$(OBJ)JPEGFormat.c \
	$(OBJ)PCXFormat.c \
	$(OBJ)PNGFormat.c \
	$(OBJ)RGBFormat.c \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.c,) \
	$(OBJ)lfbBlit.c \
	$(OBJ)lfbConvert.c \
	$(OBJ)LFBDisplayDriver.c \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesDisplayDriver.c,)
COBJECTS2 = \
	$(if $(OSX),,$(OBJ)OpenGLDisplayDriver.c) \
	$(if $(WINDOWS),$(OBJ)Win32BitmapPrinterDisplayDriver.c,) \
	$(if $(OSX),$(OBJ)CocoaOpenGLDisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleDisplayDriver.c,) \
	$(if $(WINDOWS),$(OBJ)Win32PrinterDisplayDriver.c,) \
	$(if $(LINUX),$(OBJ)XDisplayDriver.c,) \
	$(OBJ)Bitmap.c \
	$(OBJ)BitmapResource.c \
	$(OBJ)Color.c \
	$(OBJ)Display.c \
	$(OBJ)DisplaySystem.c \
	$(OBJ)FontResource.c \
	$(OBJ)Resource.c \
	$(OBJ)Surface.c \
	$(OBJ)Button.c \
	$(OBJ)CalendarControl.c \
	$(OBJ)DataBox.c \
	$(OBJ)DropBox.c \
	$(OBJ)EditBox.c \
	$(OBJ)Label.c \
	$(OBJ)ListBox.c \
	$(OBJ)Menu.c \
	$(OBJ)Picture.c \
	$(OBJ)ProgressBar.c \
	$(OBJ)ScrollBar.c \
	$(OBJ)StatusBar.c \
	$(OBJ)TabControl.c \
	$(OBJ)PaneSplitter.c \
	$(OBJ)Stacker.c \
	$(OBJ)PathBox.c \
	$(OBJ)ToolTip.c \
	$(OBJ)SelectorBar.c \
	$(OBJ)ColorPicker.c \
	$(OBJ)FileDialog.c \
	$(OBJ)FindDialog.c \
	$(OBJ)GoToDialog.c \
	$(OBJ)MessageBox.c \
	$(OBJ)ReplaceDialog.c \
	$(OBJ)WindowList.c \
	$(if $(OSX),$(OBJ)CocoaDispatch.c,)
COBJECTS3 = \
	$(if $(OSX),$(OBJ)CocoaInterface.c,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesInterface.c,) \
	$(if $(WINDOWS),$(OBJ)Win32Interface.c,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleInterface.c,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)XInterface.c,) \
	$(OBJ)TVisionSkin.c \
	$(OBJ)WindowsSkin.c \
	$(OBJ)Anchor.c \
	$(OBJ)ClipBoard.c \
	$(OBJ)Cursor.c \
	$(OBJ)Desktop3D.c \
	$(OBJ)FormDesigner.c \
	$(OBJ)GuiApplication.c \
	$(OBJ)Interface.c \
	$(OBJ)Key.c \
	$(OBJ)Skin.c \
	$(OBJ)Timer.c \
	$(OBJ)typeEdit.c \
	$(OBJ)Window.c \
	$(OBJ)dcom.c \
	$(OBJ)HTTPFile.c \
	$(OBJ)network.c \
	$(OBJ)NetworkClientFile.c \
	$(OBJ)Service.c \
	$(OBJ)Socket.c \
	$(OBJ)Array.c \
	$(OBJ)AVLTree.c \
	$(OBJ)BuiltInContainer.c \
	$(OBJ)Container.c \
	$(OBJ)CustomAVLTree.c \
	$(OBJ)LinkList.c \
	$(OBJ)List.c \
	$(OBJ)Map.c \
	$(OBJ)BinaryTree.c \
	$(OBJ)BTNode.c \
	$(OBJ)dataTypes.c \
	$(OBJ)instance.c \
	$(OBJ)String.c \
	$(OBJ)OldList.c

SYMBOLS = $(SYMBOLS1) $(SYMBOLS2) $(SYMBOLS3) $(SYMBOLS4)
SYMBOLS1 = \
	$(OBJ)Archive.sym \
	$(OBJ)BufferedFile.sym \
	$(OBJ)Date.sym \
	$(OBJ)DualPipe.sym \
	$(OBJ)EARArchive.sym \
	$(OBJ)File.sym \
	$(OBJ)FileMonitor.sym \
	$(OBJ)GlobalAppSettings.sym \
	$(OBJ)JSON.sym \
	$(OBJ)JSONGlobalSettings.sym \
	$(OBJ)memory.sym \
	$(OBJ)Mutex.sym \
	$(OBJ)Semaphore.sym \
	$(OBJ)System.sym \
	$(OBJ)TempFile.sym \
	$(OBJ)Thread.sym \
	$(OBJ)Time.sym \
	$(OBJ)unicode.sym \
	$(OBJ)units.sym \
	$(OBJ)i18n.sym \
	$(OBJ)Cube.sym \
	$(OBJ)SkyBox.sym \
	$(OBJ)Sphere.sym \
	$(OBJ)Object3DSFormat.sym \
	$(OBJ)Camera.sym \
	$(OBJ)Matrix.sym \
	$(OBJ)Mesh.sym \
	$(OBJ)Object.sym \
	$(OBJ)Plane.sym \
	$(OBJ)Quaternion.sym \
	$(OBJ)Vector3D.sym \
	$(OBJ)BMPFormat.sym \
	$(OBJ)GIFFormat.sym \
	$(OBJ)JPEGFormat.sym \
	$(OBJ)PCXFormat.sym \
	$(OBJ)PNGFormat.sym \
	$(OBJ)RGBFormat.sym \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.sym,) \
	$(OBJ)lfbBlit.sym \
	$(OBJ)lfbConvert.sym \
	$(OBJ)LFBDisplayDriver.sym
SYMBOLS2 = \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesDisplayDriver.sym,) \
	$(if $(OSX),,$(OBJ)OpenGLDisplayDriver.sym) \
	$(if $(WINDOWS),$(OBJ)Win32BitmapPrinterDisplayDriver.sym,) \
	$(if $(OSX),$(OBJ)CocoaOpenGLDisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleDisplayDriver.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32PrinterDisplayDriver.sym,) \
	$(if $(LINUX),$(OBJ)XDisplayDriver.sym,) \
	$(OBJ)Bitmap.sym \
	$(OBJ)BitmapResource.sym \
	$(OBJ)Color.sym \
	$(OBJ)Display.sym \
	$(OBJ)DisplaySystem.sym \
	$(OBJ)FontResource.sym \
	$(OBJ)Resource.sym \
	$(OBJ)Surface.sym \
	$(OBJ)Button.sym \
	$(OBJ)CalendarControl.sym \
	$(OBJ)DataBox.sym \
	$(OBJ)DropBox.sym \
	$(OBJ)EditBox.sym \
	$(OBJ)Label.sym \
	$(OBJ)ListBox.sym \
	$(OBJ)Menu.sym \
	$(OBJ)Picture.sym \
	$(OBJ)ProgressBar.sym \
	$(OBJ)ScrollBar.sym \
	$(OBJ)StatusBar.sym \
	$(OBJ)TabControl.sym \
	$(OBJ)PaneSplitter.sym \
	$(OBJ)Stacker.sym \
	$(OBJ)PathBox.sym \
	$(OBJ)ToolTip.sym \
	$(OBJ)SelectorBar.sym \
	$(OBJ)ColorPicker.sym \
	$(OBJ)FileDialog.sym \
	$(OBJ)FindDialog.sym \
	$(OBJ)GoToDialog.sym
SYMBOLS3 = \
	$(OBJ)MessageBox.sym \
	$(OBJ)ReplaceDialog.sym \
	$(OBJ)WindowList.sym \
	$(if $(OSX),$(OBJ)CocoaDispatch.sym,) \
	$(if $(OSX),$(OBJ)CocoaInterface.sym,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)NCursesInterface.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32Interface.sym,) \
	$(if $(WINDOWS),$(OBJ)Win32ConsoleInterface.sym,) \
	$(if $(or $(LINUX),$(OSX)),$(OBJ)XInterface.sym,) \
	$(OBJ)TVisionSkin.sym \
	$(OBJ)WindowsSkin.sym \
	$(OBJ)Anchor.sym \
	$(OBJ)ClipBoard.sym \
	$(OBJ)Cursor.sym \
	$(OBJ)Desktop3D.sym \
	$(OBJ)FormDesigner.sym \
	$(OBJ)GuiApplication.sym \
	$(OBJ)Interface.sym \
	$(OBJ)Key.sym \
	$(OBJ)Skin.sym \
	$(OBJ)Timer.sym \
	$(OBJ)typeEdit.sym \
	$(OBJ)Window.sym \
	$(OBJ)dcom.sym \
	$(OBJ)HTTPFile.sym \
	$(OBJ)network.sym \
	$(OBJ)NetworkClientFile.sym \
	$(OBJ)Service.sym \
	$(OBJ)Socket.sym \
	$(OBJ)Array.sym \
	$(OBJ)AVLTree.sym \
	$(OBJ)BuiltInContainer.sym \
	$(OBJ)Container.sym \
	$(OBJ)CustomAVLTree.sym \
	$(OBJ)LinkList.sym \
	$(OBJ)List.sym \
	$(OBJ)Map.sym \
	$(OBJ)BinaryTree.sym \
	$(OBJ)BTNode.sym \
	$(OBJ)dataTypes.sym \
	$(OBJ)instance.sym
SYMBOLS4 = \
	$(OBJ)String.sym \
	$(OBJ)OldList.sym

IMPORTS = $(IMPORTS1) $(IMPORTS2) $(IMPORTS3) $(IMPORTS4)
IMPORTS1 = \
	$(OBJ)Archive.imp \
	$(OBJ)BufferedFile.imp \
	$(OBJ)Date.imp \
	$(OBJ)DualPipe.imp \
	$(OBJ)EARArchive.imp \
	$(OBJ)File.imp \
	$(OBJ)FileMonitor.imp \
	$(OBJ)GlobalAppSettings.imp \
	$(OBJ)JSON.imp \
	$(OBJ)JSONGlobalSettings.imp \
	$(OBJ)memory.imp \
	$(OBJ)Mutex.imp \
	$(OBJ)Semaphore.imp \
	$(OBJ)System.imp \
	$(OBJ)TempFile.imp \
	$(OBJ)Thread.imp \
	$(OBJ)Time.imp \
	$(OBJ)unicode.imp \
	$(OBJ)units.imp \
	$(OBJ)i18n.imp \
	$(OBJ)Cube.imp \
	$(OBJ)SkyBox.imp \
	$(OBJ)Sphere.imp \
	$(OBJ)Object3DSFormat.imp \
	$(OBJ)Camera.imp \
	$(OBJ)Matrix.imp \
	$(OBJ)Mesh.imp \
	$(OBJ)Object.imp \
	$(OBJ)Plane.imp \
	$(OBJ)Quaternion.imp \
	$(OBJ)Vector3D.imp \
	$(OBJ)BMPFormat.imp \
	$(OBJ)GIFFormat.imp \
	$(OBJ)JPEGFormat.imp \
	$(OBJ)PCXFormat.imp \
	$(OBJ)PNGFormat.imp \
	$(OBJ)RGBFormat.imp \
	$(if $(WINDOWS),$(OBJ)Direct3D8DisplayDriver.imp,) \
	$(if $(WINDOWS),$(OBJ)Direct3D9DisplayDriver.imp,) \
	$(if $(WINDOWS),$(OBJ)DirectDrawDisplayDriver.imp,) \
	$(if $(WINDOWS),$(OBJ)GDIDisplayDriver.imp,) \
	$(OBJ)lfbBlit.imp \
	$(OBJ)lfbConvert.imp \
	$(OBJ)LFBDisplayDriver.imp
IMPORTS2 = \

=== eda/Makefile ===
.SILENT:
.PHONY: all cmd clean realclean distclean

# CROSS-PLATFORM MAGIC

include ../include.mk

all:
	@$(call echo,Building Ecere Data Access layer...)
	cd libeda && $(MAKE)
	@$(call echo,Building EDASQLite driver...)
	cd drivers && cd sqlite && $(MAKE)
ifdef EDASQLiteCipher
	@$(call echo,Building EDASQLiteCipher driver...)
	cd drivers && cd sqliteCipher && $(MAKE)
endif

clean:
	cd libeda && $(MAKE) clean
	cd drivers && cd sqlite && $(MAKE) clean
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) clean
endif

realclean:
	cd libeda && $(MAKE) realclean
	cd drivers && cd sqlite && $(MAKE) realclean
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) realclean
endif

distclean:
	cd libeda && $(MAKE) distclean
	cd drivers && cd sqlite && $(MAKE) distclean
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) distclean
endif

=== epj2make/Makefile ===
.PHONY: all objdir clean realclean distclean

# CONTENT

MODULE := epj2make
CONFIG := release
COMPILER := default
TARGET_TYPE = executable

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = 

CONSOLE = -mconsole

TARGET = obj/$(CONFIG).$(PLATFORM)/epj2make$(E)

OBJECTS = \
	$(OBJ)Project.o \
	$(OBJ)ProjectConfig.o \
	$(OBJ)ProjectNode.o \
	$(OBJ)IDESettings.o \
	$(OBJ)OldIDESettings.o \
	$(OBJ)StringsBox.o \
	$(OBJ)epj2make.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = \
	$(OBJ)Project.c \
	$(OBJ)ProjectConfig.c \
	$(OBJ)ProjectNode.c \
	$(OBJ)IDESettings.c \
	$(OBJ)OldIDESettings.c \
	$(OBJ)StringsBox.c \
	$(OBJ)epj2make.c

SYMBOLS = \
	$(OBJ)Project.sym \
	$(OBJ)ProjectConfig.sym \
	$(OBJ)ProjectNode.sym \
	$(OBJ)IDESettings.sym \
	$(OBJ)OldIDESettings.sym \
	$(OBJ)StringsBox.sym \
	$(OBJ)epj2make.sym

IMPORTS = \
	$(OBJ)Project.imp \
	$(OBJ)ProjectConfig.imp \
	$(OBJ)ProjectNode.imp \
	$(OBJ)IDESettings.imp \
	$(OBJ)OldIDESettings.imp \
	$(OBJ)StringsBox.imp \
	$(OBJ)epj2make.imp

SOURCES = \
	../ide/src/project/Project.ec \
	../ide/src/project/ProjectConfig.ec \
	../ide/src/project/ProjectNode.ec \
	../ide/src/IDESettings.ec \
	../ide/src/OldIDESettings.ec \
	../extras/gui/controls/StringsBox.ec \
	epj2make.ec

RESOURCES = \
	locale/zh_CN/LC_MESSAGES/epj2make.mo \
	../include.mk

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../include.mk

# TOOLCHAIN
export LD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
export DYLD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
ECP := $(call psep,../obj/$(PLATFORM)/bin/ecp)
ECC := $(call psep,../obj/$(PLATFORM)/bin/ecc)
ECS := $(call psep,../obj/$(PLATFORM)/bin/ecs)
EAR := $(call psep,../obj/$(PLATFORM)/bin/ear)

# FLAGS

CFLAGS += -fmessage-length=0 -O2 -ffast-math -m32 $(FPIC) -w \
	 -DMAKEFILE_GENERATOR

CECFLAGS =

ECFLAGS = -nolinenumbers

OFLAGS += -m32 \
	 -L../obj/$(PLATFORM)/bin \
	 -L../obj/$(PLATFORM)/lib

LIBS = -lecere $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

UPXFLAGS = -9 -q

# HARD CODED PLATFORM-SPECIFIC OPTIONS
ifdef LINUX
OFLAGS += -Wl,--no-undefined
endif

# PLATFORM-SPECIFIC OPTIONS

ifdef LINUX

endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) -console $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
	$(EAR) awq $(TARGET) ../include.mk ""
	$(EAR) awq $(TARGET) locale/zh_CN/LC_MESSAGES/epj2make.mo "locale/zh_CN/LC_MESSAGES"
	$(EAR) awq $(TARGET) locale/es_ES/LC_MESSAGES/epj2make.mo "locale/es_ES/LC_MESSAGES"
	$(call cpq,$(TARGET),../obj/$(PLATFORM)/bin/)

# SYMBOL RULES

$(OBJ)Project.sym: ../ide/src/project/Project.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/project/Project.ec -o $(OBJ)Project.sym

$(OBJ)ProjectConfig.sym: ../ide/src/project/ProjectConfig.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/project/ProjectConfig.ec -o $(OBJ)ProjectConfig.sym

$(OBJ)ProjectNode.sym: ../ide/src/project/ProjectNode.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/project/ProjectNode.ec -o $(OBJ)ProjectNode.sym

$(OBJ)IDESettings.sym: ../ide/src/IDESettings.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/IDESettings.ec -o $(OBJ)IDESettings.sym

$(OBJ)OldIDESettings.sym: ../ide/src/OldIDESettings.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../ide/src/OldIDESettings.ec -o $(OBJ)OldIDESettings.sym

$(OBJ)StringsBox.sym: ../extras/gui/controls/StringsBox.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ../extras/gui/controls/StringsBox.ec -o $(OBJ)StringsBox.sym

$(OBJ)epj2make.sym: epj2make.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c epj2make.ec -o $(OBJ)epj2make.sym

# C OBJECT RULES

$(OBJ)Project.c: ../ide/src/project/Project.ec $(OBJ)Project.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/project/Project.ec -o $(OBJ)Project.c -symbols $(OBJ)

$(OBJ)ProjectConfig.c: ../ide/src/project/ProjectConfig.ec $(OBJ)ProjectConfig.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/project/ProjectConfig.ec -o $(OBJ)ProjectConfig.c -symbols $(OBJ)

$(OBJ)ProjectNode.c: ../ide/src/project/ProjectNode.ec $(OBJ)ProjectNode.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/project/ProjectNode.ec -o $(OBJ)ProjectNode.c -symbols $(OBJ)

$(OBJ)IDESettings.c: ../ide/src/IDESettings.ec $(OBJ)IDESettings.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/IDESettings.ec -o $(OBJ)IDESettings.c -symbols $(OBJ)

$(OBJ)OldIDESettings.c: ../ide/src/OldIDESettings.ec $(OBJ)OldIDESettings.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../ide/src/OldIDESettings.ec -o $(OBJ)OldIDESettings.c -symbols $(OBJ)

$(OBJ)StringsBox.c: ../extras/gui/controls/StringsBox.ec $(OBJ)StringsBox.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ../extras/gui/controls/StringsBox.ec -o $(OBJ)StringsBox.c -symbols $(OBJ)

$(OBJ)epj2make.c: epj2make.ec $(OBJ)epj2make.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c epj2make.ec -o $(OBJ)epj2make.c -symbols $(OBJ)

# OBJECT RULES

$(OBJ)Project.o: $(OBJ)Project.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)Project.c -o $(OBJ)Project.o

$(OBJ)ProjectConfig.o: $(OBJ)ProjectConfig.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)ProjectConfig.c -o $(OBJ)ProjectConfig.o

$(OBJ)ProjectNode.o: $(OBJ)ProjectNode.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)ProjectNode.c -o $(OBJ)ProjectNode.o

$(OBJ)IDESettings.o: $(OBJ)IDESettings.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)IDESettings.c -o $(OBJ)IDESettings.o

$(OBJ)OldIDESettings.o: $(OBJ)OldIDESettings.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)OldIDESettings.c -o $(OBJ)OldIDESettings.o

$(OBJ)StringsBox.o: $(OBJ)StringsBox.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)StringsBox.c -o $(OBJ)StringsBox.o

$(OBJ)epj2make.o: $(OBJ)epj2make.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)epj2make.c -o $(OBJ)epj2make.o

$(OBJ)$(MODULE).main$(O): $(OBJ)$(MODULE).main.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.c -o $(OBJ)$(MODULE).main$(O)

clean: objdir
	$(call rmq,$(OBJ)$(MODULE).main.c $(OBJ)$(MODULE).main.ec $(OBJ)$(MODULE).main$(I) $(OBJ)$(MODULE).main$(S) $(TARGET))
	$(call rmq,$(OBJECTS))
	$(call rmq,$(COBJECTS))
	$(call rmq,$(IMPORTS))
	$(call rmq,$(SYMBOLS))

realclean:
	$(call rmrq,$(OBJ))

distclean:
	$(call rmrq,obj/)

=== ide/Makefile ===
.PHONY: all objdir clean realclean distclean

# CONTENT

MODULE := ide
CONFIG := release
COMPILER := default
TARGET_TYPE = executable

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = res/

CONSOLE = -mwindows

TARGET = obj/$(CONFIG).$(PLATFORM)/ide$(E)

OBJECTS = \
	$(OBJ)FileSystemIterator.o \
	$(OBJ)layout.o \
	$(OBJ)StringsBox.o \
	$(OBJ)ActiveCompilerDialog.o \
	$(OBJ)CompilersDetectionDialog.o \
	$(OBJ)FindInFilesDialog.o \
	$(OBJ)GlobalSettingsDialog.o \
	$(OBJ)NewProjectDialog.o \
	$(OBJ)NodeProperties.o \
	$(OBJ)ProjectActiveConfig.o \
	$(OBJ)WorkspaceSettings.o \
	$(OBJ)ProjectTabSettings.o \
	$(OBJ)Project.o \
	$(OBJ)ProjectConfig.o \
	$(OBJ)ProjectNode.o \
	$(OBJ)ProjectView.o \
	$(OBJ)Workspace.o \
	$(if $(WINDOWS),$(OBJ)vsSupport.o,) \
	$(OBJ)CodeEditor.o \
	$(OBJ)CodeObject.o \
	$(OBJ)Designer.o \
	$(OBJ)findCtx.o \
	$(OBJ)findExp.o \
	$(OBJ)findParams.o \
	$(OBJ)Sheet.o \
	$(OBJ)ToolBox.o \
	$(OBJ)debugFindCtx.o \
	$(OBJ)Debugger.o \
	$(OBJ)debugTools.o \
	$(OBJ)GDBDialog.o \
	$(OBJ)process.o \
	$(OBJ)BreakpointsView.o \
	$(OBJ)CallStackView.o \
	$(OBJ)OutputView.o \
	$(OBJ)ThreadsView.o \
	$(OBJ)WatchesView.o \
	$(OBJ)ModelView.o \
	$(OBJ)PictureEdit.o \
	$(OBJ)about.o \
	$(OBJ)ide.o \
	$(OBJ)IDESettings.o \
	$(OBJ)OldIDESettings.o \
	$(OBJ)ProjectSettings.o \
	$(OBJ)licensing.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = \
	$(OBJ)FileSystemIterator.c \
	$(OBJ)layout.c \
	$(OBJ)StringsBox.c \
	$(OBJ)ActiveCompilerDialog.c \
	$(OBJ)CompilersDetectionDialog.c \
	$(OBJ)FindInFilesDialog.c \
	$(OBJ)GlobalSettingsDialog.c \
	$(OBJ)NewProjectDialog.c \
	$(OBJ)NodeProperties.c \
	$(OBJ)ProjectActiveConfig.c \
	$(OBJ)WorkspaceSettings.c \
	$(OBJ)ProjectTabSettings.c \
	$(OBJ)Project.c \
	$(OBJ)ProjectConfig.c \
	$(OBJ)ProjectNode.c \
	$(OBJ)ProjectView.c \
	$(OBJ)Workspace.c \
	$(if $(WINDOWS),$(OBJ)vsSupport.c,) \
	$(OBJ)CodeEditor.c \
	$(OBJ)CodeObject.c \
	$(OBJ)Designer.c \
	$(OBJ)findCtx.c \
	$(OBJ)findExp.c \
	$(OBJ)findParams.c \
	$(OBJ)Sheet.c \
	$(OBJ)ToolBox.c \
	$(OBJ)debugFindCtx.c \
	$(OBJ)Debugger.c \
	$(OBJ)debugTools.c \
	$(OBJ)GDBDialog.c \
	$(OBJ)process.c \
	$(OBJ)BreakpointsView.c \
	$(OBJ)CallStackView.c \
	$(OBJ)OutputView.c \
	$(OBJ)ThreadsView.c \
	$(OBJ)WatchesView.c \
	$(OBJ)ModelView.c \
	$(OBJ)PictureEdit.c \
	$(OBJ)about.c \
	$(OBJ)ide.c \
	$(OBJ)IDESettings.c \
	$(OBJ)OldIDESettings.c \
	$(OBJ)ProjectSettings.c \
	$(OBJ)licensing.c

SYMBOLS = $(SYMBOLS1) $(SYMBOLS2)
SYMBOLS1 = \
	$(OBJ)FileSystemIterator.sym \
	$(OBJ)layout.sym \
	$(OBJ)StringsBox.sym \
	$(OBJ)ActiveCompilerDialog.sym \
	$(OBJ)CompilersDetectionDialog.sym \
	$(OBJ)FindInFilesDialog.sym \
	$(OBJ)GlobalSettingsDialog.sym \
	$(OBJ)NewProjectDialog.sym \
	$(OBJ)NodeProperties.sym \
	$(OBJ)ProjectActiveConfig.sym \
	$(OBJ)WorkspaceSettings.sym \
	$(OBJ)ProjectTabSettings.sym \
	$(OBJ)Project.sym \
	$(OBJ)ProjectConfig.sym \
	$(OBJ)ProjectNode.sym \
	$(OBJ)ProjectView.sym \
	$(OBJ)Workspace.sym \
	$(if $(WINDOWS),$(OBJ)vsSupport.sym,) \
	$(OBJ)CodeEditor.sym \
	$(OBJ)CodeObject.sym \
	$(OBJ)Designer.sym \
	$(OBJ)findCtx.sym \
	$(OBJ)findExp.sym \
	$(OBJ)findParams.sym \
	$(OBJ)Sheet.sym \
	$(OBJ)ToolBox.sym \
	$(OBJ)debugFindCtx.sym \
	$(OBJ)Debugger.sym \
	$(OBJ)debugTools.sym \
	$(OBJ)GDBDialog.sym \
	$(OBJ)process.sym \
	$(OBJ)BreakpointsView.sym \
	$(OBJ)CallStackView.sym \
	$(OBJ)OutputView.sym \
	$(OBJ)ThreadsView.sym \
	$(OBJ)WatchesView.sym \
	$(OBJ)ModelView.sym \
	$(OBJ)PictureEdit.sym \
	$(OBJ)about.sym \
	$(OBJ)ide.sym \
	$(OBJ)IDESettings.sym \
	$(OBJ)OldIDESettings.sym
SYMBOLS2 = \
	$(OBJ)ProjectSettings.sym \
	$(OBJ)licensing.sym

IMPORTS = $(IMPORTS1) $(IMPORTS2)
IMPORTS1 = \
	$(OBJ)FileSystemIterator.imp \
	$(OBJ)layout.imp \
	$(OBJ)StringsBox.imp \
	$(OBJ)ActiveCompilerDialog.imp \
	$(OBJ)CompilersDetectionDialog.imp \
	$(OBJ)FindInFilesDialog.imp \
	$(OBJ)GlobalSettingsDialog.imp \
	$(OBJ)NewProjectDialog.imp \
	$(OBJ)NodeProperties.imp \
	$(OBJ)ProjectActiveConfig.imp \
	$(OBJ)WorkspaceSettings.imp \
	$(OBJ)ProjectTabSettings.imp \
	$(OBJ)Project.imp \
	$(OBJ)ProjectConfig.imp \
	$(OBJ)ProjectNode.imp \
	$(OBJ)ProjectView.imp \
	$(OBJ)Workspace.imp \
	$(if $(WINDOWS),$(OBJ)vsSupport.imp,) \
	$(OBJ)CodeEditor.imp \
	$(OBJ)CodeObject.imp \
	$(OBJ)Designer.imp \
	$(OBJ)findCtx.imp \
	$(OBJ)findExp.imp \
	$(OBJ)findParams.imp \
	$(OBJ)Sheet.imp \
	$(OBJ)ToolBox.imp \
	$(OBJ)debugFindCtx.imp \
	$(OBJ)Debugger.imp \
	$(OBJ)debugTools.imp \
	$(OBJ)GDBDialog.imp \
	$(OBJ)process.imp \
	$(OBJ)BreakpointsView.imp \
	$(OBJ)CallStackView.imp \
	$(OBJ)OutputView.imp \
	$(OBJ)ThreadsView.imp \
	$(OBJ)WatchesView.imp \
	$(OBJ)ModelView.imp \
	$(OBJ)PictureEdit.imp \
	$(OBJ)about.imp \
	$(OBJ)ide.imp \
	$(OBJ)IDESettings.imp \
	$(OBJ)OldIDESettings.imp
IMPORTS2 = \
	$(OBJ)ProjectSettings.imp \
	$(OBJ)licensing.imp

SOURCES = \
	../extras/FileSystemIterator.ec \
	../extras/gui/layout.ec \
	../extras/gui/controls/StringsBox.ec \
	src/dialogs/ActiveCompilerDialog.ec \
	src/dialogs/CompilersDetectionDialog.ec \
	src/dialogs/FindInFilesDialog.ec \
	src/dialogs/GlobalSettingsDialog.ec \
	src/dialogs/NewProjectDialog.ec \
	src/dialogs/NodeProperties.ec \
	src/dialogs/ProjectActiveConfig.ec \
	src/dialogs/WorkspaceSettings.ec \
	src/dialogs/ProjectTabSettings.ec \
	src/project/Project.ec \
	src/project/ProjectConfig.ec \
	src/project/ProjectNode.ec \
	src/project/ProjectView.ec \
	src/project/Workspace.ec \
	$(if $(WINDOWS),src/project/vsSupport.ec,) \
	src/designer/CodeEditor.ec \
	src/designer/CodeObject.ec \
	src/designer/Designer.ec \
	src/designer/findCtx.ec \
	src/designer/findExp.ec \
	src/designer/findParams.ec \
	src/designer/Sheet.ec \
	src/designer/ToolBox.ec \
	src/debugger/debugFindCtx.ec \
	src/debugger/Debugger.ec \
	src/debugger/debugTools.ec \
	src/debugger/GDBDialog.ec \
	src/debugger/process.ec \
	src/panels/BreakpointsView.ec \
	src/panels/CallStackView.ec \
	src/panels/OutputView.ec \
	src/panels/ThreadsView.ec \
	src/panels/WatchesView.ec \
	src/documents/ModelView.ec \
	src/documents/PictureEdit.ec \
	src/about.ec \
	src/ide.ec \
	src/IDESettings.ec \
	src/OldIDESettings.ec \
	src/ProjectSettings.ec \
	src/licensing.ec

RESOURCES = $(RESOURCES1) $(RESOURCES2)
RESOURCES1 = \
	$(RES)actions/attach.png \
	$(RES)actions/delete.png \
	$(RES)actions/detach.png \
	$(RES)actions/docNew.png \
	$(RES)actions/editCopy.png \
	$(RES)actions/editDelete.png \
	$(RES)actions/delete2.png \
	$(RES)actions/build.png \
	$(RES)actions/clean.png \
	$(RES)actions/debug.png \
	$(RES)actions/docOpen.png \
	$(RES)actions/docSave.png \
	$(RES)actions/docSaveAll.png \
	$(RES)actions/pause.png \
	$(RES)actions/projAdd.png \
	$(RES)actions/projNew.png \
	$(RES)actions/projOpen.png \
	$(RES)actions/rebuild.png \
	$(RES)actions/regMakefile.png \
	$(RES)actions/relink.png \
	$(RES)actions/restart.png \
	$(RES)actions/run.png \
	$(RES)actions/skipBreaks.png \
	$(RES)actions/stepInto.png \
	$(RES)actions/stepOut.png \
	$(RES)actions/stepOver.png \
	$(RES)actions/stopDebug.png \
	$(RES)codeMarks/breakpoint.png \
	$(RES)codeMarks/breakpointDisabled.png \
	$(RES)codeMarks/breakpointHalf.png \
	$(RES)codeMarks/breakpointHalfDisabled.png \
	$(RES)codeMarks/cursor.png \
	$(RES)codeMarks/cursorError.png \
	$(RES)codeMarks/topFrame.png \
	$(RES)codeMarks/topFrameError.png \
	$(RES)codeMarks/topFrameHalf.png \
	$(RES)codeMarks/topFrameHalfError.png \
	$(RES)others/mousePointer.png \
	locale/zh_CN/LC_MESSAGES/ide.mo \
	locale/es_ES/LC_MESSAGES/ide.mo \
	../LICENSE \
	../extras/res/licenses/png.LICENSE \
	../extras/res/licenses/tango.COPYING \
	../extras/res/licenses/zlib.README \
	../extras/res/licenses/sqlite.LICENSE \
	../extras/res/licenses/jpg.LICENSE \
	../extras/res/licenses/ungif.LICENSE \
	../extras/res/licenses/freetype.LICENSE
RESOURCES2 = \
	../extras/res/licenses/harfbuzz.LICENSE \
	../extras/res/licenses/upx.LICENSE \
	../extras/res/licenses/gpl.LICENSE \
	res/ecere.jpg \
	res/ecereBack.jpg \
	res/icon.png \
	../include.mk \
	../crossplatform.mk

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../include.mk

# TOOLCHAIN
export LD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
export DYLD_LIBRARY_PATH = ../obj/$(PLATFORM)/lib/
ECP := $(call psep,../obj/$(PLATFORM)/bin/ecp)
ECC := $(call psep,../obj/$(PLATFORM)/bin/ecc)
ECS := $(call psep,../obj/$(PLATFORM)/bin/ecs)
EAR := $(call psep,../obj/$(PLATFORM)/bin/ear)

# FLAGS

CFLAGS += -fmessage-length=0 -O2 -ffast-math -m32 $(FPIC) -w

CECFLAGS =

ECFLAGS = -nolinenumbers

OFLAGS += -m32 \
	 -L../obj/$(PLATFORM)/bin \
	 -L../obj/$(PLATFORM)/lib

LIBS = -lecere $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

UPXFLAGS = -9 -q

# HARD CODED PLATFORM-SPECIFIC OPTIONS
ifdef LINUX
OFLAGS += -Wl,--no-undefined
endif

# PLATFORM-SPECIFIC OPTIONS

ifdef WINDOWS

LIBS += obj/resources.o

else
ifdef LINUX

OFLAGS += \
	 -L/usr/X11R6/lib

LIBS += -lX11

else
ifdef OSX

OFLAGS += \
	 -L/usr/X11R6/lib

LIBS += -lX11

endif
endif
endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
ifdef WINDOWS
$(TARGET): obj/resources.o
endif
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
	$(EAR) awq $(TARGET) res/ecere.jpg res/ecereBack.jpg res/icon.png ../include.mk ../crossplatform.mk ""
	$(EAR) awq $(TARGET) $(RES)actions/attach.png $(RES)actions/delete.png $(RES)actions/detach.png $(RES)actions/docNew.png $(RES)actions/editCopy.png $(RES)actions/editDelete.png $(RES)actions/delete2.png $(RES)actions/build.png $(RES)actions/clean.png $(RES)actions/debug.png "actions"
	$(EAR) awq $(TARGET) $(RES)actions/docOpen.png $(RES)actions/docSave.png $(RES)actions/docSaveAll.png $(RES)actions/pause.png $(RES)actions/projAdd.png $(RES)actions/projNew.png $(RES)actions/projOpen.png $(RES)actions/rebuild.png $(RES)actions/regMakefile.png $(RES)actions/relink.png "actions"
	$(EAR) awq $(TARGET) $(RES)actions/restart.png $(RES)actions/run.png $(RES)actions/skipBreaks.png $(RES)actions/stepInto.png $(RES)actions/stepOut.png $(RES)actions/stepOver.png $(RES)actions/stopDebug.png "actions"
	$(EAR) awq $(TARGET) $(RES)codeMarks/breakpoint.png $(RES)codeMarks/breakpointDisabled.png $(RES)codeMarks/breakpointHalf.png $(RES)codeMarks/breakpointHalfDisabled.png $(RES)codeMarks/cursor.png $(RES)codeMarks/cursorError.png $(RES)codeMarks/topFrame.png $(RES)codeMarks/topFrameError.png $(RES)codeMarks/topFrameHalf.png $(RES)codeMarks/topFrameHalfError.png "codeMarks"
	$(EAR) awq $(TARGET) $(RES)others/mousePointer.png "others"
	$(EAR) awq $(TARGET) locale/zh_CN/LC_MESSAGES/ide.mo "locale/zh_CN/LC_MESSAGES"
	$(EAR) awq $(TARGET) locale/es_ES/LC_MESSAGES/ide.mo "locale/es_ES/LC_MESSAGES"
	$(EAR) awq $(TARGET) ../LICENSE ../extras/res/licenses/png.LICENSE ../extras/res/licenses/tango.COPYING ../extras/res/licenses/zlib.README ../extras/res/licenses/sqlite.LICENSE ../extras/res/licenses/jpg.LICENSE ../extras/res/licenses/ungif.LICENSE ../extras/res/licenses/freetype.LICENSE ../extras/res/licenses/harfbuzz.LICENSE ../extras/res/licenses/upx.LICENSE "licenses"
	$(EAR) awq $(TARGET) ../extras/res/licenses/gpl.LICENSE "licenses"
	$(call cpq,$(TARGET),../obj/$(PLATFORM)/bin/)

ifdef WINDOWS
obj/resources.o: src/icon2.ico src/resources.rc | objdir
	windres src/resources.rc obj/resources.o
endif

# SYMBOL RULES

$(OBJ)FileSystemIterator.sym: ../extras/FileSystemIterator.ec

=== compiler/bootstrap/Makefile ===
.PHONY: bindir ecere libec ecp ecc ecs clean realclean distclean
.SILENT:

OBJ = obj/bin.$(PLATFORM)/

include ../../include.mk

all: bindir ecere libec ecp ecc ecs
	$(call cpq,ecp/obj/bootstrap.$(PLATFORM)/ecp$(E) ecc/obj/bootstrap.$(PLATFORM)/ecc$(E) ecs/obj/bootstrap.$(PLATFORM)/ecs$(E),$(OBJ))
	@$(call echo,All done!)

bindir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

clean: bindir
	cd ecere && $(MAKE) clean
	cd libec && $(MAKE) clean
	cd ecp && $(MAKE) clean
	cd ecc && $(MAKE) clean
	cd ecs && $(MAKE) clean
	$(call rmq,$(OBJ)ecp$(E) $(OBJ)ecc$(E) $(OBJ)ecs$(E))
ifdef WINDOWS
	$(call rmq,$(OBJ)$(LP)ecere$(SO) $(OBJ)$(LP)ec$(SO))
endif

realclean:
	$(call rmrq,$(OBJ))
	cd ecere && $(MAKE) realclean
	cd libec && $(MAKE) realclean
	cd ecp && $(MAKE) realclean
	cd ecc && $(MAKE) realclean
	cd ecs && $(MAKE) realclean

distclean:
	$(call rmrq,obj/)
	cd ecere && $(MAKE) distclean
	cd libec && $(MAKE) distclean
	cd ecp && $(MAKE) distclean
	cd ecc && $(MAKE) distclean
	cd ecs && $(MAKE) distclean

ecere:
	@$(call echo,Building ecere...)
	cd ecere && $(MAKE)
	
libec:
	@$(call echo,Building ec...)
	cd libec && $(MAKE)

ecp: ecere libec
	@$(call echo,Building ecp...)
	cd ecp && $(MAKE)

ecc: ecere libec
	@$(call echo,Building ecc...)
	cd ecc && $(MAKE)

ecs: ecere libec
	@$(call echo,Building ecs...)
	cd ecs && $(MAKE)

=== compiler/ecc/Makefile ===
.PHONY: all objdir clean realclean distclean

# CONTENT

MODULE := ecc
CONFIG := release
COMPILER := default
TARGET_TYPE = executable

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = 

CONSOLE = -mconsole

TARGET = obj/$(CONFIG).$(PLATFORM)/ecc$(E)

OBJECTS = \
	$(OBJ)ecc.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = \
	$(OBJ)ecc.c

SYMBOLS = \
	$(OBJ)ecc.sym

IMPORTS = \
	$(OBJ)ecc.imp

SOURCES = \
	ecc.ec

RESOURCES = \
	locale/zh_CN/LC_MESSAGES/ecc.mo \
	locale/es_ES/LC_MESSAGES/ecc.mo

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../../include.mk

# TOOLCHAIN

export LD_LIBRARY_PATH = ../../obj/$(PLATFORM)/lib/
export DYLD_LIBRARY_PATH = ../../obj/$(PLATFORM)/lib/
ECP := $(call psep,../bootstrap/obj/bin.$(PLATFORM)/ecp)
ECC := $(call psep,../bootstrap/obj/bin.$(PLATFORM)/ecc)
ECS := $(call psep,../bootstrap/obj/bin.$(PLATFORM)/ecs)
EAR := $(call psep,../../obj/$(PLATFORM)/bin/ear)

# FLAGS

CFLAGS += -fmessage-length=0 -O2 -ffast-math -m32 $(FPIC) -w

CECFLAGS =

ECFLAGS = -nolinenumbers

OFLAGS += -m32 \
	 -L../../obj/$(PLATFORM)/bin \
	 -L../../obj/$(PLATFORM)/lib

LIBS = -lecere $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

UPXFLAGS = -9 -q

# HARD CODED PLATFORM-SPECIFIC OPTIONS
ifdef LINUX
OFLAGS += -Wl,--no-undefined
endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) -console $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
	$(EAR) awq $(TARGET) locale/zh_CN/LC_MESSAGES/ecc.mo "locale/zh_CN/LC_MESSAGES"
	$(EAR) awq $(TARGET) locale/es_ES/LC_MESSAGES/ecc.mo "locale/es_ES/LC_MESSAGES"
	$(call cpq,$(TARGET),../../obj/$(PLATFORM)/bin/)

# SYMBOL RULES

$(OBJ)ecc.sym: ecc.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ecc.ec -o $(OBJ)ecc.sym

# C OBJECT RULES

$(OBJ)ecc.c: ecc.ec $(OBJ)ecc.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ecc.ec -o $(OBJ)ecc.c -symbols $(OBJ)

# IMPLICIT OBJECT RULE

$(OBJ)%$(O) : $(OBJ)%.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $< -o $@

# OBJECT RULES

$(OBJ)$(MODULE).main$(O): $(OBJ)$(MODULE).main.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.c -o $(OBJ)$(MODULE).main$(O)

clean: objdir
	$(call rmq,$(OBJ)$(MODULE).main.c $(OBJ)$(MODULE).main.ec $(OBJ)$(MODULE).main$(I) $(OBJ)$(MODULE).main$(S) $(TARGET))
	$(call rmq,$(OBJECTS))
	$(call rmq,$(COBJECTS))
	$(call rmq,$(IMPORTS))
	$(call rmq,$(SYMBOLS))

realclean:
	$(call rmrq,$(OBJ))

distclean:
	$(call rmrq,obj/)

=== compiler/ecp/Makefile ===
.PHONY: all objdir clean realclean distclean

# CONTENT

MODULE := ecp
CONFIG := release
COMPILER := default
TARGET_TYPE = executable

OBJ = obj/$(CONFIG).$(PLATFORM)/

RES = 

CONSOLE = -mconsole

TARGET = obj/$(CONFIG).$(PLATFORM)/ecp$(E)

OBJECTS = \
	$(OBJ)ecp.o \
	$(OBJ)$(MODULE).main$(O)

COBJECTS = \
	$(OBJ)ecp.c

SYMBOLS = \
	$(OBJ)ecp.sym

IMPORTS = \
	$(OBJ)ecp.imp

SOURCES = \
	ecp.ec

RESOURCES = \
	locale/zh_CN/LC_MESSAGES/ecp.mo \
	locale/es_ES/LC_MESSAGES/ecp.mo

ifndef DEBIAN_PACKAGE
CFLAGS =
endif
OFLAGS =

# CROSS-PLATFORM MAGIC

include ../../include.mk

# TOOLCHAIN

export LD_LIBRARY_PATH = ../../obj/$(PLATFORM)/lib/
export DYLD_LIBRARY_PATH = ../../obj/$(PLATFORM)/lib/
ECP := $(call psep,../bootstrap/obj/bin.$(PLATFORM)/ecp)
ECC := $(call psep,../bootstrap/obj/bin.$(PLATFORM)/ecc)
ECS := $(call psep,../bootstrap/obj/bin.$(PLATFORM)/ecs)
EAR := $(call psep,../../obj/$(PLATFORM)/bin/ear)

# FLAGS

CFLAGS += -fmessage-length=0 -O2 -ffast-math -m32 $(FPIC) -w

CECFLAGS =

ECFLAGS = -nolinenumbers

OFLAGS += -m32 \
	 -L../../obj/$(PLATFORM)/bin \
	 -L../../obj/$(PLATFORM)/lib

LIBS = -lecere $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

UPXFLAGS = -9 -q

# HARD CODED PLATFORM-SPECIFIC OPTIONS
ifdef LINUX
OFLAGS += -Wl,--no-undefined
endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) -console $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
	$(EAR) awq $(TARGET) locale/zh_CN/LC_MESSAGES/ecp.mo "locale/zh_CN/LC_MESSAGES"
	$(EAR) awq $(TARGET) locale/es_ES/LC_MESSAGES/ecp.mo "locale/es_ES"
	$(call cpq,$(TARGET),../../obj/$(PLATFORM)/bin/)

# SYMBOL RULES

$(OBJ)ecp.sym: ecp.ec
	$(ECP) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) -c ecp.ec -o $(OBJ)ecp.sym

# C OBJECT RULES

$(OBJ)ecp.c: ecp.ec $(OBJ)ecp.sym | $(SYMBOLS)
	$(ECC) $(CECFLAGS) $(ECFLAGS) $(CFLAGS) $(FVISIBILITY) -c ecp.ec -o $(OBJ)ecp.c -symbols $(OBJ)

# IMPLICIT OBJECT RULE

$(OBJ)%$(O) : $(OBJ)%.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $< -o $@

# OBJECT RULES

$(OBJ)$(MODULE).main$(O): $(OBJ)$(MODULE).main.c
	$(CC) $(CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.c -o $(OBJ)$(MODULE).main$(O)

clean: objdir
	$(call rmq,$(OBJ)$(MODULE).main.c $(OBJ)$(MODULE).main.ec $(OBJ)$(MODULE).main$(I) $(OBJ)$(MODULE).main$(S) $(TARGET))
	$(call rmq,$(OBJECTS))
	$(call rmq,$(COBJECTS))
	$(call rmq,$(IMPORTS))
	$(call rmq,$(SYMBOLS))

realclean:
	$(call rmrq,$(OBJ))

distclean:
	$(call rmrq,obj/)

=== debian/changelog ===
ecere-sdk (0.44.01-1) experimental; urgency=low

  * Initial packaging of Ecere SDK for Debian. (Closes: #665332, LP: #394998)

 -- Jerome St-Louis <jerstlouis@gmail.com>  Tue, 14 Aug 2012 06:58:00 -0400

=== debian/control ===
Source: ecere-sdk
Section: devel
Priority: optional
Maintainer: Jerome St-Louis <jerstlouis@gmail.com>
Build-Depends:
 autotools-dev,
 debhelper (>= 7.0.50~),
 libfontconfig1-dev,
 libfreetype6-dev,
 libgif-dev,
 libgl1-mesa-glx,
 libgl1-mesa-dev,
 libjpeg62-dev,
 libncurses5-dev,
 libpng12-dev,
 libsqlite3-dev,
 libx11-dev,
 libxext-dev,
 libxrender-dev,
 linux-libc-dev,
 upx-ucl,
 zlib1g-dev,
 libffi-dev
Standards-Version: 3.9.3
Homepage: http://www.ecere.com/

Package: ecere-sdk
Architecture: i386 armel armhf powerpc
Depends: ecere-dev, ecere-samples, ecere-extras, libeda0, libedasqlite0, ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Ecere cross-platform SDK
 This package is a metapackage providing
 the entire Ecere cross-platform SDK
 (ecere-dev, ecere-samples, ecere-extras,
 libeda0, libedasqlite0).

Package: ecere-dev
Architecture: i386 armel armhf powerpc
Depends: fonts-freefont-ttf, libec0 (= ${binary:Version}), libecerecom0 (= ${binary:Version}), ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Ecere SDK Development Tools
 This package provides the compiling tools
 for the eC language, the Ecere IDE,
 as well as the symlinks for the Ecere
 libraries.

Package: libecere0
Section: libs
Architecture: i386 armel armhf powerpc
Depends: ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Ecere Runtime Library
 This package provides the Linux version
 of Ecere's cross-platform runtime library
 for running applications built using the
 Ecere SDK. It includes a GUI toolkit,
 2D/3D graphics engine, networking engine
 as well as system functionality.

Package: libecerecom0
Section: libs
Architecture: i386 armel armhf powerpc
Depends: ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: eC Core Runtime Library
 This package provides the bare minimum
 runtime library for applications
 written in eC.

Package: libec0
Section: libs
Architecture: i386 armel armhf powerpc
Depends: libecere0 (= ${binary:Version}), ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Ecere Compiler Library
 This package provides the eC compiler.
 It is used by the Ecere IDE, as well
 as the eC compiling tools (ecp, ecc, ecs).
 It could also be used by applications
 wanting to parse or compile eC code.

Package: libeda0
Section: libs
Architecture: i386 armel armhf powerpc
Depends: libecere0, ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Ecere Data Access
 This package provides the Ecere
 Data Access RDBMS abstraction layer.
 The Ecere Database (EDB) engine is built-in.
 For SQLite support, the SQLite driver
 (libedasqlite0) is also required.

Package: libedasqlite0
Section: libs
Architecture: i386 armel armhf powerpc
Depends: libeda0, ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: EDA SQLite Driver
 This package provides SQLite driver
 for building database applications
 with the Ecere Database Access layer.

Package: ecere-samples
Architecture: all
Depends: ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Project samples for the Ecere SDK
 This package contains samples for
 multimedia, database, graphics,
 communication, and other useful
 software that can be created with
 the Ecere SDK.

Package: ecere-extras
Architecture: all
Depends: ${devel:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Extras for the Ecere SDK
 This package provides additional Ecere
 functionality, such as SSL Sockets,
 Audio, in the form of source code.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEBIAN_PACKAGE=1

%:
	dh $@

override_dh_install:
ifeq ($(DEB_HOST_ARCH),amd64)
	cp debian/libecere0.install.in64 debian/libecere0.install
	cp debian/libecerecom0.install.in64 debian/libecerecom0.install
	cp debian/libeda0.install.in64 debian/libeda0.install
	cp debian/libedasqlite0.install.in64 debian/libedasqlite0.install
	cp debian/libec0.install.in64 debian/libec0.install
	cp debian/ecere-dev.install.in64 debian/ecere-dev.install
endif

ifeq ($(DEB_HOST_ARCH),i386)
	cp debian/libecere0.install.in32 debian/libecere0.install
	cp debian/libecerecom0.install.in32 debian/libecerecom0.install
	cp debian/libeda0.install.in32 debian/libeda0.install
	cp debian/libedasqlite0.install.in32 debian/libedasqlite0.install
	cp debian/libec0.install.in32 debian/libec0.install
	cp debian/ecere-dev.install.in32 debian/ecere-dev.install
endif
	dh_install

override_dh_strip:

=== debian/watch ===
version=3
https://github.com/ecere/sdk/tags .*/tarball/(\d[\d\.]+)
